import requests
import time
import datetime
import pymysql
import random
import traceback
from log_settings import *
import logging
auto_follow_url = "http://earth.igengmei.com/api/v1/follow"

login_url = "http://earth.igengmei.com/api/account/login_pwd"

def index_first():
    try:
        r1 = requests.get(login_url)
        return r1.cookies.get_dict()
    except:

        logging.error("index_first:%s" % traceback.format_exc())

        return None

def get_majia():

    try:
        data = open("batch user gen")

        list=[]

        for i in data:
            list.append(i.strip('\n').strip(','))

        maj = random.randint(1,len(list))

        user_id=list[maj-1]

        return user_id

    except:
        logging.error("catch exception,get_majia:%s" % traceback.format_exc())
        return None

def logins():

    try:

        user_id=get_majia()

        cookies = index_first()

        post_dict={
            'account_type':2,
            'pwd':'123456',
            'email':user_id
        }
        response = requests.post(
            url=login_url,
            data=post_dict,
            cookies=cookies
        )

        headers=response.headers

        cook = headers['Set-Cookie'].split(";")

        cook = cook[0].split('=')[1]

        logging.info("response.text :%s"%response.text)

        if cook is not None:

            return {'sessionid': cook}

    except:

        logging.error("catch exception,logins:%s" % traceback.format_exc())

        return None

def follow(cookies_get, id):

    try:
        post_dict = {
            'type': 1,
            'id': id
        }
        response = requests.post(url=auto_follow_url,
                                 cookies=cookies_get,
                                 data=post_dict)

        logging.info("response.text:%s" % response.text)

    except:

        logging.error("catch exception,logins:%s" % traceback.format_exc())

def time_conv(numtime):
    try:
        now = datetime.datetime.now()
        yes_time = now - datetime.timedelta(days=numtime)
        yes_time_str = yes_time.strftime('%Y-%m-%d')
        return yes_time_str
    except:
        return None

def get_data(numtime):
    try:
        db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123',
                             db="alpha", port=3306)
        cursor = db.cursor()
        cursor.execute("SELECT distinct(user_id) FROM topic WHERE is_online=1 and create_time LIKE '%%%%%s%%%%'" % numtime)
        data = cursor.fetchall()
        user_id = list(data)
        logging.info("Database version : %s " % user_id)
        db.close()
        return user_id
    except:
        logging.error("catch exception,get_data:%s" % traceback.format_exc())
        return None

if __name__ == "__main__":

    try:

        time_list = [1,2,3,4,5,6,7,11]

        for i in range(len(time_list)):

            if time_list[i] != 11:

                numtime = time_conv(time_list[i])

                user_id = get_data(numtime)

                for j in user_id:

                    id = int(j[0])

                    follow_num = random.randint(1,2)

                    for i in range(follow_num):

                        # time.sleep(random.randint(10, 50))

                        cookies=logins()

                        if cookies is not None:

                            follow(cookies, id)

    except:
        logging.error("catch exception,main:%s" % traceback.format_exc())


