import requests
import time
import datetime
import pymysql
import random
import traceback
from log_settings import *
import logging
auto_follow_url = "http://earth.igengmei.com/api/v1/follow"

login_url = "http://earth.igengmei.com/api/account/login_pwd"

def index_first():
    try:
        r1 = requests.get(login_url)
        return r1.cookies.get_dict()
    except:

        logging.error("index_first:%s" % traceback.format_exc())

        return None

def get_majia():

    try:
        data = open("batch user gen")

        list=[]

        for i in data:
            list.append(i.strip('\n').strip(','))

        maj = random.randint(1,len(list))

        user_id=list[maj-1]

        return user_id

    except:
        logging.error("catch exception,get_majia:%s" % traceback.format_exc())
        return None

def logins():

    try:

        user_id=get_majia()

        cookies = index_first()

        post_dict={
            'account_type':2,
            'pwd':'123456',
            'email':user_id
        }
        response = requests.post(
            url=login_url,
            data=post_dict,
            cookies=cookies
        )

        headers=response.headers

        cook = headers['Set-Cookie'].split(";")

        cook = cook[0].split('=')[1]

        logging.info("response.text :%s"%response.text)

        if cook is not None:

            return {'sessionid': cook}

    except:

        logging.error("catch exception,logins:%s" % traceback.format_exc())

        return None

def follow(cookies_get, id):

    try:
        post_dict = {
            'type': 1,
            'id': id
        }
        response = requests.post(url=auto_follow_url,
                                 cookies=cookies_get,
                                 data=post_dict)

        logging.info("response.text:%s" % response.text)

    except:

        logging.error("catch exception,logins:%s" % traceback.format_exc())

def time_conv(numtime):
    try:
        now = datetime.datetime.now()
        yes_time = now - datetime.timedelta(days=numtime)
        yes_time_str = yes_time.strftime('%Y-%m-%d')
        return yes_time_str
    except:
        return None

def get_commnet_id(numtime):

    db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123',
                         db="alpha", port=3306)
    cursor = db.cursor()

    cursor.execute(
        "SELECT  user_id FROM reply WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_comment = cursor.fetchall()

    cursor.execute(

        "SELECT  t.user_id  from topic t left join reply r on  r.topic_id = t.id WHERE  r.create_time LIKE '%%%%%s%%%%'" % numtime)

    data_reply_topic = cursor.fetchall()

    cursor.execute(

        "SELECT  r.user_id  from reply r left join reply p on  r.replied_id = p.replied_id  WHERE  p.create_time LIKE '%%%%%s%%%%'" % numtime)

    data_reply_reply = cursor.fetchall()


    cursor.execute(

        "SELECT  user_id FROM group_user_role  WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_group_follow = cursor.fetchall()

    cursor.execute(

        "select  user_id from account_user  WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_new_user = cursor.fetchall()


    data_id = list(data_comment)
    data1_id=list(data_reply_topic)
    data2_id=list(data_group_follow)
    data3_id=list(data_new_user)
    data_reply_reply = list(data_reply_reply)

    user_id = []

    for i in data_id:
        if i[0]  is not None:
            user_id.append(i)
    for i in data1_id:
        if i[0]  is not None:
            user_id.append(i)
    for i in data2_id:
        if i[0]  is not None:
            user_id.append(i)
    for i in data3_id:
        if i[0]  is not None:
            user_id.append(i)
    for i in data_reply_reply:
        if i[0]  is not None:
            user_id.append(i)

    logging.info("Database version : %s " % user_id)

    db.close()

    return user_id

if __name__ == "__main__":

    try:

        numtime = time_conv(1)

        user_id = get_commnet_id(numtime)

        for j in user_id:

            id = int(j[0])

            follow_num = random.randint(0, 1)

            for i in range(follow_num):

                # time.sleep(random.randint(10, 50))

                cookies = logins()

                if cookies is not None:

                    follow(cookies, id)

    except:
        logging.error("catch exception,main:%s" % traceback.format_exc())



















