import requests
import time
import datetime
import pymysql
import random
import pandas as pd
import traceback
from log_settings import *
import logging
auto_click_url = "http://earth.igengmei.com/api/v1/like"
auto_reply_url = "http://earth.igengmei.com/api/v1/reply/create"
auto_follow_url = "http://earth.igengmei.com/api/v1/follow"
login_url = "http://earth.igengmei.com/api/account/login_pwd"


def index_first():
    try:
        r1 = requests.get(login_url)
        return r1.cookies.get_dict()
    except:

        logging.error("index_first:%s" % traceback.format_exc())

        return None

def get_majia():

    try:
        data = open("batch user gen")

        list=[]

        for i in data:
            list.append(i.strip('\n').strip(','))

        maj = random.randint(1,len(list))

        user_id=list[maj-1]

        return user_id

    except:
        logging.error("catch exception,get_majia:%s" % traceback.format_exc())
        return None

def logins(user_id):
    try:

        cookies = index_first()

        post_dict = {
            'account_type': 2,
            'pwd': '123456',
            'email': user_id
        }
        response = requests.post(
            url=login_url,
            data=post_dict,
            cookies=cookies
        )

        headers = response.headers

        cook = headers['Set-Cookie'].split(";")

        cook = cook[0].split('=')[1]

        logging.info("response.text :%s" % response.text)

        if cook is not None:

            return {'sessionid': cook}

    except:

        logging.error("catch exception,logins:%s" % traceback.format_exc())

        return None

def follow(cookies_get, id):

    try:
        post_dict = {
            'type': 1,
            'id': id
        }
        response = requests.post(url=auto_follow_url,
                                 cookies=cookies_get,
                                 data=post_dict)

        logging.info("response.text:%s" % response.text)

    except:

        logging.error("catch exception,logins:%s" % traceback.format_exc())

def time_conv():
    try:
        now = datetime.datetime.now()
        yes_time = now - datetime.timedelta(minutes=15)
        return yes_time
    except:
        return None

def get_follw_majia(numtime):
    try:
        db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123',
                             db="alpha", port=3306)
        cursor = db.cursor()
        cursor.execute("select temp1.user_id,temp1.email,temp2.user_id from account_user_auth  temp1  left join  (select user_id,follow_id,create_time from user_follow)  temp2 on temp1.user_id = temp2.follow_id where temp1.email in ('s_05tmwu@shadow.com','s_07CRHt@shadow.com','s_0bdxxU@shadow.com','s_0mfxcO@shadow.com','s_0u6eaV@shadow.com','s_0UudEr@shadow.com','s_1b3v5V@shadow.com','s_ZVuLyC@shadow.com','s_1dbAoA@shadow.com','s_1dholX@shadow.com','s_1EpLlt@shadow.com') and  temp2.create_time like  '%%%%%s%%%%'  "%(numtime))
        data = cursor.fetchall()
        data=list(data)
        logging.info("Database version : %s " % data)
        db.close()
        return data
    except:
        logging.error("catch exception,get_data:%s" % traceback.format_exc())
        return None

if __name__ == "__main__":

    try:

        numtime=time_conv()

        # get majia zhanghao

        data = get_follw_majia(numtime)

        dict_follow_id = {}

        for j in data:

            if j[2] != None:

                if j[0] not in dict_follow_id.keys():

                    dict_follow_id.setdefault(j[0], [])

                    dict_follow_id[j[0]].append(j[2])

                else:
                    dict_follow_id[j[0]].append(j[2])

        dict_email = {}

        for j in data:

            if j[2] != None:

                if j[0] not in dict_email.keys():

                    dict_email.setdefault(j[0], [])

                    dict_email[j[0]].append(j[1])

                else:
                    dict_email[j[0]].append(j[1])

        for key, value in dict_follow_id.items():

            id = dict_email[key][0]

            for i in value:

                # time.sleep(random.randint(10, 50))

                cookies=logins(id)

                if cookies is not None:

                    follow(cookies,i)

    except:
        logging.error("catch exception,main:%s" % traceback.format_exc())











